'use strict';

class Union {}

const ENTITY_KEY = Symbol("entity");
function Entity(options) {
  return function (target, propertyKey) {
    const entityMap = Reflect.getMetadata(ENTITY_KEY, target.constructor) ?? new Map();
    if (!entityMap.has(propertyKey)) {
      entityMap.set(propertyKey, options);
      Reflect.defineMetadata(ENTITY_KEY, entityMap, target.constructor);
    }
  };
}

exports.ENTITY_KEY = ENTITY_KEY;
exports.Entity = Entity;
exports.Union = Union;
